<?php

namespace NoccyLabs\GdCanvas\Drawable;
use GdImage;
use NoccyLabs\GdImage\Image;
use NoccyLabs\GdImage\ImageInterface;

abstract class Drawable implements ImageInterface
{

    private int $width;

    private int $height;

    public function resize(int $width, int $height): void
    {
        $this->width = $width;
        $this->height = $height;
    }

    abstract protected function draw(Image $image, int $width, int $height): void;

    public function getGdImage(): GdImage
    {
        $image = new Image($this->width, $this->height);
        $this->draw($image, $this->width, $this->height);
        return $image->getGdImage();
    }
}