<?php

namespace NoccyLabs\GdCanvas;

use GdImage;
use NoccyLabs\GdCanvas\Drawable\Drawable;
use NoccyLabs\GdImage\Font\FontInterface;
use NoccyLabs\GdImage\Image;
use NoccyLabs\GdImage\ImageInterface;
use NoccyLabs\GdImage\Point;
use NoccyLabs\GdImage\Rect;

class DrawableObject extends CanvasObject
{
    private Rect $rect;

    private Drawable|ImageInterface $drawable;

    public function __construct(Drawable|ImageInterface $drawable, Rect $rect)
    {
        $this->rect = $rect;
        $this->drawable = $drawable;
    }    

    public function render(GdImage $image)
    {
        [$x, $y, $width, $height] = $this->rect->getRect();

        if ($this->drawable instanceof Drawable) {
            $this->drawable->resize($width, $height);
        }

        $src = $this->drawable->getGdImage();

        imagecopy($image, $src, $x, $y, 0, 0, $width, $height);
    }

}

